<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAvailabilityInformations ArrayType
 * @subpackage Arrays
 */
class ArrayOfAvailabilityInformations extends AbstractStructArrayBase
{
    /**
     * The availabilityInformations
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AvailabilityInformations[]
     */
    public $availabilityInformations;
    /**
     * Constructor method for ArrayOfAvailabilityInformations
     * @uses ArrayOfAvailabilityInformations::setAvailabilityInformations()
     * @param \StructType\AvailabilityInformations[] $availabilityInformations
     */
    public function __construct(array $availabilityInformations = array())
    {
        $this
            ->setAvailabilityInformations($availabilityInformations);
    }
    /**
     * Get availabilityInformations value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AvailabilityInformations[]|null
     */
    public function getAvailabilityInformations()
    {
        return isset($this->availabilityInformations) ? $this->availabilityInformations : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAvailabilityInformations method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAvailabilityInformations method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAvailabilityInformationsForArrayConstraintsFromSetAvailabilityInformations(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAvailabilityInformationsAvailabilityInformationsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAvailabilityInformationsAvailabilityInformationsItem instanceof \StructType\AvailabilityInformations) {
                $invalidValues[] = is_object($arrayOfAvailabilityInformationsAvailabilityInformationsItem) ? get_class($arrayOfAvailabilityInformationsAvailabilityInformationsItem) : sprintf('%s(%s)', gettype($arrayOfAvailabilityInformationsAvailabilityInformationsItem), var_export($arrayOfAvailabilityInformationsAvailabilityInformationsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The availabilityInformations property can only contain items of type \StructType\AvailabilityInformations, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set availabilityInformations value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AvailabilityInformations[] $availabilityInformations
     * @return \ArrayType\ArrayOfAvailabilityInformations
     */
    public function setAvailabilityInformations(array $availabilityInformations = array())
    {
        // validation for constraint: array
        if ('' !== ($availabilityInformationsArrayErrorMessage = self::validateAvailabilityInformationsForArrayConstraintsFromSetAvailabilityInformations($availabilityInformations))) {
            throw new \InvalidArgumentException($availabilityInformationsArrayErrorMessage, __LINE__);
        }
        if (is_null($availabilityInformations) || (is_array($availabilityInformations) && empty($availabilityInformations))) {
            unset($this->availabilityInformations);
        } else {
            $this->availabilityInformations = $availabilityInformations;
        }
        return $this;
    }
    /**
     * Add item to availabilityInformations value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailabilityInformations $item
     * @return \ArrayType\ArrayOfAvailabilityInformations
     */
    public function addToAvailabilityInformations(\StructType\AvailabilityInformations $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AvailabilityInformations) {
            throw new \InvalidArgumentException(sprintf('The availabilityInformations property can only contain items of type \StructType\AvailabilityInformations, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->availabilityInformations[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AvailabilityInformations|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AvailabilityInformations|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AvailabilityInformations|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AvailabilityInformations|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AvailabilityInformations|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string availabilityInformations
     */
    public function getAttributeName()
    {
        return 'availabilityInformations';
    }
}
