<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEstablishmentPaymentMean ArrayType
 * @subpackage Arrays
 */
class ArrayOfEstablishmentPaymentMean extends AbstractStructArrayBase
{
    /**
     * The PaymentMean
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EstablishmentPaymentMean[]
     */
    public $PaymentMean;
    /**
     * Constructor method for ArrayOfEstablishmentPaymentMean
     * @uses ArrayOfEstablishmentPaymentMean::setPaymentMean()
     * @param \StructType\EstablishmentPaymentMean[] $paymentMean
     */
    public function __construct(array $paymentMean = array())
    {
        $this
            ->setPaymentMean($paymentMean);
    }
    /**
     * Get PaymentMean value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EstablishmentPaymentMean[]|null
     */
    public function getPaymentMean()
    {
        return isset($this->PaymentMean) ? $this->PaymentMean : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentMean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentMean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentMeanForArrayConstraintsFromSetPaymentMean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEstablishmentPaymentMeanPaymentMeanItem) {
            // validation for constraint: itemType
            if (!$arrayOfEstablishmentPaymentMeanPaymentMeanItem instanceof \StructType\EstablishmentPaymentMean) {
                $invalidValues[] = is_object($arrayOfEstablishmentPaymentMeanPaymentMeanItem) ? get_class($arrayOfEstablishmentPaymentMeanPaymentMeanItem) : sprintf('%s(%s)', gettype($arrayOfEstablishmentPaymentMeanPaymentMeanItem), var_export($arrayOfEstablishmentPaymentMeanPaymentMeanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentMean property can only contain items of type \StructType\EstablishmentPaymentMean, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentMean value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EstablishmentPaymentMean[] $paymentMean
     * @return \ArrayType\ArrayOfEstablishmentPaymentMean
     */
    public function setPaymentMean(array $paymentMean = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentMeanArrayErrorMessage = self::validatePaymentMeanForArrayConstraintsFromSetPaymentMean($paymentMean))) {
            throw new \InvalidArgumentException($paymentMeanArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentMean) || (is_array($paymentMean) && empty($paymentMean))) {
            unset($this->PaymentMean);
        } else {
            $this->PaymentMean = $paymentMean;
        }
        return $this;
    }
    /**
     * Add item to PaymentMean value
     * @throws \InvalidArgumentException
     * @param \StructType\EstablishmentPaymentMean $item
     * @return \ArrayType\ArrayOfEstablishmentPaymentMean
     */
    public function addToPaymentMean(\StructType\EstablishmentPaymentMean $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EstablishmentPaymentMean) {
            throw new \InvalidArgumentException(sprintf('The PaymentMean property can only contain items of type \StructType\EstablishmentPaymentMean, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentMean[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EstablishmentPaymentMean|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EstablishmentPaymentMean|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EstablishmentPaymentMean|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EstablishmentPaymentMean|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EstablishmentPaymentMean|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentMean
     */
    public function getAttributeName()
    {
        return 'PaymentMean';
    }
}
