<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StartingFromPriceFile StructType
 * @subpackage Structs
 */
class StartingFromPriceFile extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The PortalCmsId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $PortalCmsId;
    /**
     * The PrivateTitle
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PrivateTitle;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Title;
    /**
     * The Tag
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tag;
    /**
     * The availabilityInformationsList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfAvailabilityInformations
     */
    public $availabilityInformationsList;
    /**
     * The Periods
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPeriod
     */
    public $Periods;
    /**
     * The Filters
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfStartingFromPriceFileFilter
     */
    public $Filters;
    /**
     * Constructor method for StartingFromPriceFile
     * @uses StartingFromPriceFile::setId()
     * @uses StartingFromPriceFile::setPortalCmsId()
     * @uses StartingFromPriceFile::setPrivateTitle()
     * @uses StartingFromPriceFile::setTitle()
     * @uses StartingFromPriceFile::setTag()
     * @uses StartingFromPriceFile::setAvailabilityInformationsList()
     * @uses StartingFromPriceFile::setPeriods()
     * @uses StartingFromPriceFile::setFilters()
     * @param int $id
     * @param int $portalCmsId
     * @param string $privateTitle
     * @param string $title
     * @param string $tag
     * @param \ArrayType\ArrayOfAvailabilityInformations $availabilityInformationsList
     * @param \ArrayType\ArrayOfPeriod $periods
     * @param \ArrayType\ArrayOfStartingFromPriceFileFilter $filters
     */
    public function __construct($id = null, $portalCmsId = null, $privateTitle = null, $title = null, $tag = null, \ArrayType\ArrayOfAvailabilityInformations $availabilityInformationsList = null, \ArrayType\ArrayOfPeriod $periods = null, \ArrayType\ArrayOfStartingFromPriceFileFilter $filters = null)
    {
        $this
            ->setId($id)
            ->setPortalCmsId($portalCmsId)
            ->setPrivateTitle($privateTitle)
            ->setTitle($title)
            ->setTag($tag)
            ->setAvailabilityInformationsList($availabilityInformationsList)
            ->setPeriods($periods)
            ->setFilters($filters);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\StartingFromPriceFile
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get PortalCmsId value
     * @return int
     */
    public function getPortalCmsId()
    {
        return $this->PortalCmsId;
    }
    /**
     * Set PortalCmsId value
     * @param int $portalCmsId
     * @return \StructType\StartingFromPriceFile
     */
    public function setPortalCmsId($portalCmsId = null)
    {
        // validation for constraint: int
        if (!is_null($portalCmsId) && !(is_int($portalCmsId) || ctype_digit($portalCmsId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($portalCmsId, true), gettype($portalCmsId)), __LINE__);
        }
        $this->PortalCmsId = $portalCmsId;
        return $this;
    }
    /**
     * Get PrivateTitle value
     * @return string|null
     */
    public function getPrivateTitle()
    {
        return $this->PrivateTitle;
    }
    /**
     * Set PrivateTitle value
     * @param string $privateTitle
     * @return \StructType\StartingFromPriceFile
     */
    public function setPrivateTitle($privateTitle = null)
    {
        // validation for constraint: string
        if (!is_null($privateTitle) && !is_string($privateTitle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($privateTitle, true), gettype($privateTitle)), __LINE__);
        }
        $this->PrivateTitle = $privateTitle;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \StructType\StartingFromPriceFile
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->Title = $title;
        return $this;
    }
    /**
     * Get Tag value
     * @return string|null
     */
    public function getTag()
    {
        return $this->Tag;
    }
    /**
     * Set Tag value
     * @param string $tag
     * @return \StructType\StartingFromPriceFile
     */
    public function setTag($tag = null)
    {
        // validation for constraint: string
        if (!is_null($tag) && !is_string($tag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tag, true), gettype($tag)), __LINE__);
        }
        $this->Tag = $tag;
        return $this;
    }
    /**
     * Get availabilityInformationsList value
     * @return \ArrayType\ArrayOfAvailabilityInformations|null
     */
    public function getAvailabilityInformationsList()
    {
        return $this->availabilityInformationsList;
    }
    /**
     * Set availabilityInformationsList value
     * @param \ArrayType\ArrayOfAvailabilityInformations $availabilityInformationsList
     * @return \StructType\StartingFromPriceFile
     */
    public function setAvailabilityInformationsList(\ArrayType\ArrayOfAvailabilityInformations $availabilityInformationsList = null)
    {
        $this->availabilityInformationsList = $availabilityInformationsList;
        return $this;
    }
    /**
     * Get Periods value
     * @return \ArrayType\ArrayOfPeriod|null
     */
    public function getPeriods()
    {
        return $this->Periods;
    }
    /**
     * Set Periods value
     * @param \ArrayType\ArrayOfPeriod $periods
     * @return \StructType\StartingFromPriceFile
     */
    public function setPeriods(\ArrayType\ArrayOfPeriod $periods = null)
    {
        $this->Periods = $periods;
        return $this;
    }
    /**
     * Get Filters value
     * @return \ArrayType\ArrayOfStartingFromPriceFileFilter|null
     */
    public function getFilters()
    {
        return $this->Filters;
    }
    /**
     * Set Filters value
     * @param \ArrayType\ArrayOfStartingFromPriceFileFilter $filters
     * @return \StructType\StartingFromPriceFile
     */
    public function setFilters(\ArrayType\ArrayOfStartingFromPriceFileFilter $filters = null)
    {
        $this->Filters = $filters;
        return $this;
    }
}
